using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace SelectPdf.Samples.Pages
{
    public class ConvertMultipleUrlsToPdfModel : PageModel
    {
        public void OnGet()
        {

        }

        [BindProperty]
        public string TxtUrl1 { get; set; }

        [BindProperty]
        public string TxtUrl2 { get; set; }

        [BindProperty]
        public string TxtUrl3 { get; set; }


        public IActionResult OnPost()
        {
            // create a new pdf document 
            PdfDocument doc = new PdfDocument();

            // add a new page to the document
            PdfPage page = doc.AddPage();

            // add the first url
            PdfHtmlElement html1 = new PdfHtmlElement(TxtUrl1);
            PdfRenderingResult result = page.Add(html1);

            // get the last page of the previous conversion
            PdfPage page2 = doc.Pages[result.PdfPageLastIndex];

            // add the second url
            PdfHtmlElement html2 = new PdfHtmlElement(result.PdfPageLastRectangle.Left,
                result.PdfPageLastRectangle.Bottom, TxtUrl2);
            result = page2.Add(html2);

            // get the last page of the previous conversion
            PdfPage page3 = doc.Pages[result.PdfPageLastIndex];

            // add the third url
            PdfHtmlElement html3 = new PdfHtmlElement(result.PdfPageLastRectangle.Left,
                result.PdfPageLastRectangle.Bottom, TxtUrl3);
            result = page3.Add(html3);

            // save pdf document
            byte[] pdf = doc.Save();

            // close pdf document
            doc.Close();

            // return resulted pdf document
            FileResult fileResult = new FileContentResult(pdf, "application/pdf");
            fileResult.FileDownloadName = "Document.pdf";
            return fileResult;
        }
    }
}